%Solution for Homework 1 Exercise 12

% Exercise 12) Consider a real data set that contains 2 vectors. rt is a 
% vector of reaction times of one subject on a visual attention task. 
% cue is a vector describing if the cue was 
% valid (value 1), invalid (value 2) or absent (value 3).
clear;
N = 20; % number of samples

% First, we initialize rt and cue with random values

% From the text of the exercise we know that values in rt can exceed 1000 and can 
% be less then 100. Therefore, we generate a vector rt containing random
% values between 1 and 3000.
rt = randi([1,3000],1,N);
cue = randi([1,3],1,N); % We use randi to create a random vector with 
                        % values 1, 2 or 3
disp('rt:');
disp(rt);
disp('cue:');
disp(cue);

% a)	Create a logical vector called valid which defines all the trials 
% with valid cues.

valid = (cue==ones(1,N)); % We compare the elements of cue against a mask of ones. 
                          % When cue=1 then the trial is valid.

% b)	Use the vector valid to find the mean of reaction time on valid cues.

v = rt(valid); %here we extract from rt only the reaction time for valid cues.
disp('valid rt: ');
disp(v);
avg_rt_valid = sum(v)/length(v);
fprintf('Mean of reaction time on valid cues = %.3f\n', avg_rt_valid);

% c)	Error trials are ones where the reaction time is less than 
% 100 msec or more than 1000 msec. Create a logical vector called error 
% defining which trials are errors.

errors = (rt<100); % We crete a logical vector whose elements are true if the 
                   % corresponding elements of rt < 100.
errors = errors | (rt>1000);    % We add to the logical vector the value true 
                                % for each element of rt > 1000.

% d)	Use both the vectors error and valid to find the mean of reaction 
% times for correct valid trials. 

correctvalid= ~errors & valid;	% correctvalid is a logical vector whose elements
                                % are true if the trial is correct and valid.
vc = rt(correctvalid);
disp('valid and correct rt: ');
disp(vc);

avg_rt_vc = sum(vc)/length(vc); % average rt for valid and correct trials.
fprintf('Mean of reaction time on valid and correct trials = %.3f\n', avg_rt_vc);
